---
name: Bug report
about: Create a report to help us improve.
labels: bug
---

**Bug description**

A clear and concise description of what the bug is.

* OS: [e.g. Linux/MacOS/FreeBSD/OpenBSD]
* OS Version: [e.g. Debian 11, FreeBSD 11]
* Architecture: [amd64, arm]

Place `tarantool --version` output here.

**Steps to reproduce**

Run two tarantool instances iteractively.

1. Type '...' in console 1.
1. Type '...' in console 2.

or reproducer script:

```
#!/usr/bin/env tarantool

<your code here>
```

How to run:

Just type `tarantool test.lua`.

**Actual behavior**

A clear and concise description of what you see.

**Expected behavior**

A clear and concise description of what you expected to happen.
